SystemOrganization addCategory: #Deprecator!

Error subclass: #DeprecatorError
	instanceVariableNames: 'sinceString useSelector useClass useClassIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecator'!

!DeprecatorError methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/10/2013 11:41'!
browseRecommended
	useClass 
		ifNil: [
			useSelector 
				ifNil: [self error: 'This deprecation does not suggest any replacement.']
				ifNotNil: [SystemNavigation default browseAllImplementorsOf: useSelector]
			]
		ifNotNil: [
			useSelector 
				ifNil: [self shouldBeImplemented]
				ifNotNil: [
					useClassIsMeta
						ifTrue: [((Smalltalk classNamed: useClass) compiledMethodAt: useSelector) browse]
						ifFalse: [((Smalltalk classNamed: useClass) class compiledMethodAt: useSelector) browse].
					]
			].! !

!DeprecatorError methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/10/2013 10:43'!
signal
	self writeMessageText.
	super signal.! !

!DeprecatorError methodsFor: 'accessing' stamp: 'HwaJong 7/10/2013 09:53'!
sinceString: aString 
	sinceString := aString! !

!DeprecatorError methodsFor: 'accessing' stamp: 'HwaJong 7/10/2013 10:36'!
useClass: aSymbol 
	useClass := aSymbol ! !

!DeprecatorError methodsFor: 'accessing' stamp: 'HwaJong 7/10/2013 11:24'!
useClassIsMeta: aBoolean
	useClassIsMeta := aBoolean! !

!DeprecatorError methodsFor: 'accessing' stamp: 'HwaJong 7/10/2013 10:33'!
useSelector: aSymbol 
	useSelector := aSymbol ! !

!DeprecatorError methodsFor: 'as yet unclassified' stamp: 'HwaJong 7/10/2013 11:27'!
writeMessageText
	|tc deprecationContext senderMethod|
	tc := thisContext.
	deprecationContext := tc sender sender sender.
	senderMethod := deprecationContext method.
	
	useClass 
		ifNil: [
			useSelector 
				ifNil: [self messageText: (senderMethod methodClass printString, ' ', senderMethod selector printString), ' is deprecated']
				ifNotNil: [self messageText: (senderMethod methodClass printString, ' ', senderMethod selector printString), ' is deprecated. Use ', useSelector printString]
			]
		ifNotNil: [
			useSelector 
				ifNil: [self shouldBeImplemented]
				ifNotNil: [
					useClassIsMeta
						ifTrue: [self messageText: (senderMethod methodClass printString, ' ', senderMethod selector printString), ' is deprecated. Use ', useClass, ' class ', useSelector printString, ' instead'.]
						ifFalse: [self messageText: (senderMethod methodClass printString, ' ', senderMethod selector printString), ' is deprecated. Use ', useClass, ' ', useSelector printString, ' instead'].
					]
			].! !

!Object methodsFor: '*Deprecator' stamp: 'HwaJong 7/10/2013 11:36'!
deprecatedSince: dateString
	|deprecator|
	deprecator := DeprecatorError new.
	deprecator
		sinceString: dateString;
		signal! !

!Object methodsFor: '*Deprecator' stamp: 'HwaJong 7/10/2013 11:41'!
deprecatedSince: dateString useClass: classNameSymbol classSideSelector: selector
	|deprecator|
	deprecator := DeprecatorError new.
	deprecator
		sinceString: dateString;
		useClassIsMeta:  true;
		useClass: classNameSymbol;
		useSelector: selector;
		signal! !

!Object methodsFor: '*Deprecator' stamp: 'HwaJong 7/10/2013 11:31'!
deprecatedSince: dateString useClass: classNameSymbol instanceSideSelector: selector
	|deprecator|
	deprecator := DeprecatorError new.
	deprecator
		sinceString: dateString;
		useClassIsMeta: false;
		useClass: classNameSymbol;
		useSelector: selector;
		signal! !

!Object methodsFor: '*Deprecator' stamp: 'HwaJong 7/10/2013 11:37'!
deprecatedSince: dateString useSelector: selector
	|deprecator|
	deprecator := DeprecatorError new.
	deprecator
		sinceString: dateString;
		useSelector: selector;
		signal! !
